/* -*-comment-start: "//";comment-end:""-*-
 * Mes --- Maxwell Equations of Software
 * Copyright © 2018 Jan (janneke) Nieuwenhuizen <janneke@gnu.org>
 *
 * This file is part of Mes.
 *
 * Mes is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or (at
 * your option) any later version.
 *
 * Mes is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Mes.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <libmes.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>

int g_alarm_handled_p = 0;

void
handler (int signum)
{
  eputs ("handle:"); eputs (itoa (signum)); eputs ("\n");
  if (signum != SIGALRM)
    exit (1);
  g_alarm_handled_p = 1;
}

int
main (void)
{
  signal (SIGALRM, handler);
  kill (getpid (), SIGALRM);
  if (!g_alarm_handled_p)
    return 2;
  return 0;
}
